#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>

#define DEL 10

void tree(int x1,int y1,int x2,int y2,int level,int k,int size,float ang)
{
  float ang1,ang2;
  int x11,y11,x12,y12,i,len, tmp;
  int x31,y31,x32,y32;
  int x21,y21,x22,y22;
  int x41,y41,x42,y42;
  int x51,y51,x52,y52;
  int x61,y61,x62,y62;
  tmp=sqrt(pow(x1-x2,2)+pow(y1-y2,2));
  x2+=(tmp-random(tmp))/DEL;
  y2+=(tmp-random(tmp))/DEL;
  line(x1,y1,x2,y2);
  k++;
  len=size;
  for(i=1;i<=k;i++)
	 len/=2.5;
  ang1=ang-M_PI/6;
  ang2=ang+M_PI/6;
  x11=(x1/4+x2*3/4);
  y11=(y1/4+y2*3/4);
  x12=x11+(len*cos(ang1));
  y12=y11-(len*sin(ang1));

  x21=(x1/2+x2/2);
  y21=(y1/2+y2/2);
  x22=x21+(len*cos(ang1));
  y22=y21-(len*sin(ang1));

  x31=(x1*3/4+x2/4);
  y31=(y1*3/4+y2/4);
  x32=x31+(len*cos(ang1));
  y32=y31-(len*sin(ang1));

  x41=(x1/4+x2*3/4);
  y41=(y1/4+y2*3/4);
  x42=x41+(len*cos(ang2));
  y42=y41-(len*sin(ang2));

  x51=(x1/2+x2/2);
  y51=(y1/2+y2/2);
  x52=x51+(len*cos(ang2));
  y52=y51-(len*sin(ang2));

  x61=(x1*3/4+x2/4);
  y61=(y1*3/4+y2/4);
  x62=x61+(len*cos(ang2));
  y62=y61-(len*sin(ang2));

  if (k<level)
  {
		  tree(x11,y11,x12,y12,level,k,size,ang1);
		  tree(x21,y21,x22,y22,level,k,size,ang1);
		  tree(x31,y31,x32,y32,level,k,size,ang1);
		  tree(x41,y41,x42,y42,level,k,size,ang2);
		  tree(x51,y51,x52,y52,level,k,size,ang2);
		  tree(x61,y61,x62,y62,level,k,size,ang2);

  }
  k--;
}

int main(void)
{

  int gdriver = DETECT, gmode, errorcode;
  int x1,x2,y1,y2;
  int k,size,level,color,number;
  float ang;
  size=500;k=0;color=0;

  initgraph(&gdriver, &gmode, "c:\\bc\\bgi");
  errorcode = graphresult();
  if (errorcode != grOk)
  {
	  printf("Graphics error: %s\n", grapherrormsg(errorcode));
	  printf("Press any key to halt:");
	  getch();
	 exit(1);
  }
  do
  {
		cleardevice();
		setcolor(7);
		outtext("press space for exit");
		number=random(10)+7;
	  for(number;number>0;number--)
	  {
		setcolor(color);
		color++;

		x2=x1=random(getmaxx());

		y1=random(getmaxy());
		y2=y1*.2;

		level=random(5)+3;

		if (y1>y2) ang=M_PI_2;
			else ang=-M_PI_2;
		tree(x1,y1,x2,y2,level,k,size,ang);
	  }
  }while(getch()!=' ');
  return 0;
}